<?php
#------------------------------------------
# Biblioteca de funciones para los plugins para WDTV Live
#------------------------------------------
function _esPremium(&$auth){
	if (file_exists('/conf/config')) {
		$config = file_get_contents('/conf/config');
		if(preg_match('/MEGA_AUTH=\'(.+)\'/', $config, $config_result)) {
			$auth = $config_result[1];
			return true;
		}
	}
	return false;
}

#Funciones de Cartulas
function _IconosGeneros() {
	$categories = array(
	'novedades' => 'http://i52.tinypic.com/f4faqo.jpg',
	'arte-y-cine' => 'http://i55.tinypic.com/ay67px.jpg',
	'de-accion' => 'http://i56.tinypic.com/6fps.jpg',
	'accion' => 'http://i56.tinypic.com/6fps.jpg',
	'anime' => 'http://i54.tinypic.com/k9t7ig.jpg',
	'animacion-e-infantil' => 'http://i52.tinypic.com/wmj76v.jpg',
	'animacion' => 'http://i52.tinypic.com/wmj76v.jpg',
	'artes-marciales' => 'http://i53.tinypic.com/2d6shoj.jpg',
	'de-artes-marciales' => 'http://i53.tinypic.com/2d6shoj.jpg',
	'aventura' => 'http://i53.tinypic.com/2yvks4k.jpg',
	'aventuras' => 'http://i53.tinypic.com/2yvks4k.jpg',
	'de-aventura' => 'http://i53.tinypic.com/2yvks4k.jpg',
	'belico' => 'http://i52.tinypic.com/vxm3pd.jpg',
	'guerra' => 'http://i52.tinypic.com/vxm3pd.jpg',
	'biografias' => 'http://i53.tinypic.com/6te2km.jpg',
	'biografica' => 'http://i54.tinypic.com/1ql3wm.jpg',
	'biografico' => 'http://i54.tinypic.com/1ql3wm.jpg',
	'ciencia-ficcion' => 'http://i53.tinypic.com/95yo7t.jpg',
	'de-ciencia-ficcion' => 'http://i53.tinypic.com/95yo7t.jpg',
	'ficcion' => 'http://i53.tinypic.com/95yo7t.jpg',
	'ciencia-y-tecnologia' =>  'http://i56.tinypic.com/o7on11.jpg',
	'cine-negro' => 'http://i54.tinypic.com/2ahh6ie.jpg',
	'comedia' => 'http://i53.tinypic.com/34pnudl.jpg',
	'de-comedia' => 'http://i53.tinypic.com/34pnudl.jpg',
	'comedia-dramatica' =>  'http://i53.tinypic.com/34ebyop.jpg',
	'comedia-romantica' =>  'http://i56.tinypic.com/4uynbs.jpg',
	'cortometrajes' => 'http://i53.tinypic.com/xgdvg2.jpg',
	'deporte' => 'http://i56.tinypic.com/4g12qv.jpg',
	'de-deportes' => 'http://i56.tinypic.com/4g12qv.jpg',
	'deportes' => 'http://i56.tinypic.com/4g12qv.jpg',
	'de-dibujos' => 'http://i51.tinypic.com/25as12d.jpg',
	'de-internacionales' => 'http://i56.tinypic.com/25jwjrs.jpg',
	'de-miniseries' => 'http://i51.tinypic.com/2hmlxnd.jpg',
	'de-nacionales' => 'http://i54.tinypic.com/1zl7wud.jpg',
	'de-programas-tv' => 'http://i53.tinypic.com/35beek3.jpg',
	'de-telenovelas' => 'http://i52.tinypic.com/o7t4wl.jpg',
	'drama' => 'http://i53.tinypic.com/34ebyop.jpg',
	'de-drama' => 'http://i53.tinypic.com/34ebyop.jpg',
	'drama-historico' =>  'http://i51.tinypic.com/117g19i.jpg',
	'de-fantastico' => 'http://i56.tinypic.com/34he4v9.jpg',
	'documental' => 'http://i56.tinypic.com/8y5b42.jpgg',
	'hispano-latino' =>  'http://i54.tinypic.com/1zl7wud.jpg',
	'erotico' => 'http://i52.tinypic.com/34s5dtc.jpg',
	'fantastico' => 'http://i56.tinypic.com/34he4v9.jpg',
	'familiar' =>  'http://i52.tinypic.com/28cimtc.jpg',
	'historia' =>  'http://i54.tinypic.com/mcamtt.jpg',
	'infantil' => 'http://i56.tinypic.com/9jkd4m.jpg',
	'infantiles' => 'http://i56.tinypic.com/9jkd4m.jpg',
	'de-infantil' => 'http://i56.tinypic.com/9jkd4m.jpg',
	'intriga' => 'http://i51.tinypic.com/2yopnp3.jpg',
	'musical' =>  'http://i54.tinypic.com/1z648j8.jpg',
	'naturaleza' =>  'http://i51.tinypic.com/296daqg.jpg',
	'otros' =>  'http://i52.tinypic.com/24434zq.jpg',
	'policiaco' => 'http://i56.tinypic.com/bfj7md.jpg',
	'politica' =>  'http://i51.tinypic.com/2yzilcp.jpg',
	'romance' =>  'http://i56.tinypic.com/4uynbs.jpg',
	'de-romance' =>  'http://i56.tinypic.com/4uynbs.jpg',
	'serie-documental' =>  'http://i53.tinypic.com/2ldy33d.jpg',
	'social' =>  'http://i52.tinypic.com/mtmkw9.jpg',
	'suspense' =>  'http://i53.tinypic.com/eqt8r5.jpg',
	'suspenso' =>  'http://i53.tinypic.com/eqt8r5.jpg',
	'miedo-terror' =>  'http://i54.tinypic.com/w000ar.jpg',
	'terror' =>  'http://i54.tinypic.com/w000ar.jpg',
	'thriller' =>  'http://i52.tinypic.com/25k205h.jpg',
	'thriller-peliculas-online-es' =>  'http://i52.tinypic.com/25k205h.jpg',
	'de-thriller' =>  'http://i52.tinypic.com/25k205h.jpg',
	'western' =>  'http://i54.tinypic.com/2lq4ns.jpg',
	'vosubtituladas' =>  'http://i56.tinypic.com/25jwjrs.jpg' ,
	);
	return $categories;
}

function _IconosAlfabeto($tipo) {
	$iconos = array();
	if ($tipo=='2' || $tipo=='3') $iconos[] ='http://i53.tinypic.com/11azl2a.jpg';
	$iconos[] ='http://i55.tinypic.com/1g6nps.jpg';
	$iconos[] ='http://i55.tinypic.com/f1z9k7.jpg';
	$iconos[] ='http://i55.tinypic.com/igequr.jpg';
	$iconos[] ='http://i55.tinypic.com/312ctvs.jpg';
	$iconos[] ='http://i56.tinypic.com/1zr16v6.jpg';
	$iconos[] ='http://i51.tinypic.com/2i23n1x.jpg';
	$iconos[] ='http://i55.tinypic.com/90adll.jpg';
	$iconos[] ='http://i51.tinypic.com/o55c9l.jpg';
	$iconos[] ='http://i53.tinypic.com/u101l.jpg';
	$iconos[] ='http://i55.tinypic.com/se4kye.jpg';
	$iconos[] ='http://i55.tinypic.com/2i1z3ic.jpg';
	$iconos[] ='http://i51.tinypic.com/28bz9t4.jpg';
	$iconos[] ='http://i53.tinypic.com/12383s8.jpg';
	$iconos[] ='http://i55.tinypic.com/2e4c381.jpg';
	if ($tipo=='3' || $tipo=='4') $iconos[] ='http://i55.tinypic.com/2e4c381.jpg';
	$iconos[] ='http://i56.tinypic.com/2mzwm6s.jpg';
	$iconos[] ='http://i54.tinypic.com/2qn62s1.jpg';
	$iconos[] ='http://i53.tinypic.com/ngabdi.jpg';
	$iconos[] ='http://i53.tinypic.com/xc24qs.jpg';
	$iconos[] ='http://i51.tinypic.com/iy1k5g.jpg';
	$iconos[] ='http://i52.tinypic.com/2v325uh.jpg';
	$iconos[] ='http://i53.tinypic.com/24y0fm9.jpg';
	$iconos[] ='http://i55.tinypic.com/29erke9.jpg';
	$iconos[] ='http://i56.tinypic.com/2lucqh0.jpg';
	$iconos[] ='http://i52.tinypic.com/2ci9151.jpg';
	$iconos[] ='http://i55.tinypic.com/14c6zo0.jpg';
	$iconos[] ='http://i56.tinypic.com/28l7z2d.jpg';
	if ($tipo=='1' || $tipo=='4') $iconos[] ='http://i53.tinypic.com/11azl2a.jpg';
	return $iconos;
}

#Funciones de Listados
function _CrearItems($lista,$plugin,$tipo) {
	for ($z = 0; $z < sizeof($lista['titulo']); $z++) {
		$t = (is_array($tipo)) ? $tipo[$z] : $tipo;
		$data = array($t => $lista['enlace'][$z]);
		$dataString = http_build_query($data, 'pluginvar_');
		$retMediaItems[] = array (
		'id' => 'umsp://plugins/'.$plugin.'?' . $dataString,
		'dc:title' => html_entity_decode($lista['titulo'][$z],0,"UTF-8"),
		'upnp:album_art'=> $lista['caratula'][$z],
		'upnp:class' => 'object.container',
		);
	}
	if ($lista['serie']!='') $retMediaItems[] = _favoritos($lista['url'],$plugin,$lista['caratula'][0],$lista['serie']);
	return $retMediaItems;
}

function _pluginCreateVideoItems($lista,$plugin) {
	$cookie = '';
	$premium = _esPremium($cookie);
	$MUItems = array();
	$listado = array_merge($lista, array('cookie' => $cookie));
	if ($premium) $MUItems = _CrearMUItems($listado,$plugin);
	$retMediaItems = array_merge(_CrearMVItems($listado,$plugin,$premium),$MUItems);
	return $retMediaItems;
}

function _CrearMVItems($lista,$plugin,$premium) {
	$retMediaItems = array();
	for ($z = 0; $z < sizeof($lista['megavid']); $z++) {
		$urlvideo = $lista['megavid'][$z];
                $cod8=$lista['megavid'][$z]; 
		if ($premium) {
		  $urlvideo = _obtenerUrlMegavideoPremium($urlvideo,$lista['cookie']);
		  if ($urlvideo == '') {
		      $urlvideo = _AdivinarUrlMegavideoPremium($cod8,$lista['cookie']);
		    }
                $p ='premium';
		}
		else $urlvideo = _obtenerUrlMegavideo($urlvideo);
		$t = (is_array($lista['titulo'])) ? $lista['titulo'][$z] : $lista['titulo']." (MV #".($z+1).")";
		$retMediaItems[] = array (
		'id' => 'umsp://plugins/'.$plugin.'?' . $lista['megavid'][$z],
		'dc:title' => html_entity_decode($t,0,"UTF-8"),
		'res' => $urlvideo,
		'upnp:class' => 'object.item.videoitem',
		'upnp:album_art'=> 'http://i34.tinypic.com/t53qbr.jpg',
		'protocolInfo' => '*:*:*:*'
		);
	}
	return $retMediaItems;
}

function _CrearMUItems($lista,$plugin) {
	$retMediaItems = array();
	$opts = array(
		'http' => array(
			'method' => "HEAD",
			'max_redirects' => '0',
			'header' => 'Cookie: user=' . $lista['cookie'] . "\r\n"));
	$context = stream_context_create($opts);

	$offset = sizeof($lista['megavid']);
	for ($z = 0; $z < sizeof($lista['megaup']); $z++) {
		$t = (is_array($lista['titulo'])) ? $lista['titulo'][($z+$offset)] : $lista['titulo']." (MU #".($z+1).")";
		$getHeaders = @file_get_contents("http://www.megaupload.com/?d=" . $lista['megaup'][$z], false, $context);
		if (preg_match('/ocation: (.+)/',$http_response_header[8],$res)) {
			$part = (sizeof($lista['megaup']) > 1) ? "/" . ($z+1) : "";
			$retMediaItems[] = array (
			'id' => 'umsp://plugins/'.$plugin.'?' . $lista['megaup'][$z],
			'dc:title' => html_entity_decode($t,0,"UTF-8"),
			'res' => $res[1],
			'upnp:class' => 'object.item.videoitem',
			'upnp:album_art'=> 'http://i36.tinypic.com/332w29c.jpg',
			'protocolInfo' => '*:*:*:*'
			);
		}
	}
	return $retMediaItems;
}

function _CrearLista($url,$patron,$orden,$aux){
		$html = file_get_contents($url);	
		if ($aux != '') $todo = _DoblePatron($html,$aux,$patron);
		else preg_match_all($patron,$html,$todo);
		return array ('titulo' => $todo[$orden[0]],'enlace' => $todo[$orden[1]],'caratula' =>$todo[$orden[2]]);
}

function _CrearListaAlfabetica($url,$patron,$orden,$tipo,$aux){
		$lista = _CrearLista($url,$patron,$orden,$aux);
		$lista['caratula'] = _IconosAlfabeto($tipo);
		return $lista;
}

function _CrearListaCategoria($url,$patron,$orden,$aux){
		$lista = _CrearLista($url,$patron,$orden,$aux);
		$iconos = _IconosGeneros();
		foreach ($lista['enlace'] as $value) $caratulas[] = $iconos[$value];
		$lista['caratula'] = $caratulas;
		return $lista;
}

function _CrearListaMega($url,$pMV,$pMU,$pTitulo,$orden){
		$html = file_get_contents($url);
		preg_match_all($pMV,$html,$megavid);
		preg_match($pTitulo,$html,$title);
		preg_match_all($pMU,$html,$megaup);
		return array ('megavid' => $megavid[$orden[0]],'megaup' => $megaup[$orden[1]],'titulo' => $title[$orden[2]]);
}

function _CrearTemporada($url,$patTemp,$patSerie,$orden){
		$html = file_get_contents($url);
		preg_match_all($patTemp,$html,$todo);
		preg_match_all($patSerie,$html,$serie);
		foreach ($todo[$orden[0]] as &$value) {$titulo[]= 'Temporada '.$value; $value = $url.'_'.$value; $caratula[]=$serie[$orden[1]][0];}
		return array ('titulo' => $titulo,'enlace' => $todo[$orden[0]],'caratula' => $caratula,'serie' =>$serie[$orden[2]][0],'url' => $url);
}

function _DoblePatron($html,$p1,$p2){
		preg_match_all($p1,$html,$auxiliar);
		preg_match_all($p2,$auxiliar[1][0],$resultado);
		return $resultado;
}

# Funcin de Bsqueda
function _pluginSearch($prmQuery) {
	$cadena = _cadenaBusqueda();
	preg_match('/and dc:title contains "(.*?)"/', $prmQuery, $searchstring);
	if ( isset($searchstring[1]) ) {
		$dataString = http_build_query(array('busqueda' => $cadena.$searchstring[1]), 'pluginvar_');
		return _pluginMain($dataString);
	} else {
		return null;
	}
}

# Funciones para los favoritos
function _pluginFavorito($url) {
	$datos = explode("_|_", $url);
	$path = '/conf/favoritos.xml';
	if (substr(sprintf('%o', fileperms($path)), -4)=='0644') shell_exec('sudo chmod a+w '.$path);
	$items = new SimpleXMLElement($path, null, true);

	$favorito= $items->addChild('favorito');
	$favorito->addAttribute('nombre', utf8_encode($datos[3]));
	$favorito->addAttribute('url', $datos[0]);
	$favorito->addAttribute('imagen', $datos[2]);
	$favorito->addAttribute('website', $datos[1]);
	$favorito->addAttribute('orden', ($items->count()));
	$items->asXML($path);

	$tipourl = 'movie_url';

	$data = array($tipourl => $datos[0]);
	$dataString = http_build_query($data, 'pluginvar_');
	$retMediaItems[] = array (
		'id' => 'umsp://plugins/'.$datos[1].'?'.$dataString,
		'dc:title' => html_entity_decode('Se ha incluido en favoritos (Volver)',0,"UTF-8"),
		'upnp:class' => 'object.container',
		);
	return $retMediaItems;
}

function _favoritos($url,$website,$caratula,$serie) {
	$data = array('favoritos' => $url.'_|_'.$website.'_|_'.$caratula.'_|_'.$serie);
	$dataString = http_build_query($data, 'pluginvar_');
	$item = array (
		'id' => 'umsp://plugins/'.$website.'?'.$dataString,
		'dc:title' => html_entity_decode('Incluir en favoritos',0,"UTF-8"),
		'upnp:class' => 'object.container',
		'upnp:album_art'=> 'http://i52.tinypic.com/x0xm2s.jpg',
		);
	return $item;
}

# decrypt function from megavideo.class.php by luruke
function decrypt($str, $key1, $key2) {
  $reg1 = array();

  for($reg3=0; $reg3<strlen($str); $reg3++) {
    $reg0 = $str[$reg3];
    switch($reg0) {
      case '0': $reg1[] = '0000'; break;
      case '1': $reg1[] = '0001'; break;
      case '2': $reg1[] = '0010'; break;
      case '3': $reg1[] = '0011'; break;
      case '4': $reg1[] = '0100'; break;
      case '5': $reg1[] = '0101'; break;
      case '6': $reg1[] = '0110'; break;
      case '7': $reg1[] = '0111'; break;
      case '8': $reg1[] = '1000'; break;
      case '9': $reg1[] = '1001'; break;
      case 'a': $reg1[] = '1010'; break;
      case 'b': $reg1[] = '1011'; break;
      case 'c': $reg1[] = '1100'; break;
      case 'd': $reg1[] = '1101'; break;
      case 'e': $reg1[] = '1110'; break;
      case 'f': $reg1[] = '1111'; break;
    }
  }

  $reg1 = join($reg1);
  $reg6 = array();

  for($reg3=0; $reg3<384; $reg3++) {
    $key1 = ($key1 * 11 + 77213) % 81371;
    $key2 = ($key2 * 17 + 92717) % 192811;
    $reg6[] = ($key1 + $key2) % 128;
  }

  for($reg3=256; $reg3>=0; $reg3--) {
    $reg5 = $reg6[$reg3];
    $reg4 = $reg3 % 128;
    $reg8 = $reg1[$reg5];
    $reg1[$reg5] = $reg1[$reg4];
    $reg1[$reg4] = $reg8;
  }

  for($reg3=0; $reg3<128; $reg3++) {
    $reg1[$reg3] = $reg1[$reg3] ^ ($reg6[$reg3+256] & 1);
  }

  $reg12 = $reg1;
  $reg7 = array();

  for($reg3=0; $reg3<strlen($reg12); $reg3+=4) {
    $reg9 = substr($reg12, $reg3, 4);
    $reg7[] = $reg9;
  }

  $reg2 = array();

  for($reg3=0; $reg3<count($reg7); $reg3++) {
    $reg0 = $reg7[$reg3];
    switch($reg0) {
      case '0000': $reg2[] = '0'; break;
      case '0001': $reg2[] = '1'; break;
      case '0010': $reg2[] = '2'; break;
      case '0011': $reg2[] = '3'; break;
      case '0100': $reg2[] = '4'; break;
      case '0101': $reg2[] = '5'; break;
      case '0110': $reg2[] = '6'; break;
      case '0111': $reg2[] = '7'; break;
      case '1000': $reg2[] = '8'; break;
      case '1001': $reg2[] = '9'; break;
      case '1010': $reg2[] = 'a'; break;
      case '1011': $reg2[] = 'b'; break;
      case '1100': $reg2[] = 'c'; break;
      case '1101': $reg2[] = 'd'; break;
      case '1110': $reg2[] = 'e'; break;
      case '1111': $reg2[] = 'f'; break;
    }
  }

  return join($reg2);

}

function _obtenerUrlMegavideoPremium($codigo,$cookie) {
  $xmlMegavideo = file_get_contents("http://www.megavideo.com/xml/player_login.php?u=".$cookie."&v=".$codigo);
  preg_match('/downloadurl="(.*?)"/',$xmlMegavideo,$url2);
  $myurl = rawurldecode($url2[1]);
  return $myurl;
}

function _AdivinarUrlMegavideoPremium($codigo,$cookie) {
$url='http://www.megavideo.com?d='.$codigo;
$optional_headers="Cookie: ".$cookie."\r\n";
$PaginaMegavideo=hacer_post_request($url, $data, $optional_headers);
preg_match("/previewplayer\/\?v=(........).*new=2/",$PaginaMegavideo,$codmegavideo);
$nuevocod=$codmegavideo['1'];
$myurlvideo = _obtenerUrlMegavideoPremium($nuevocod,$cookie);
return $myurlvideo;
}
        

function _obtenerUrlMegavideo($codigo) {
  $xmlMegavideo = file_get_contents("http://www.megavideo.com/xml/videolink.php?v=".$codigo."&id=".time());
  preg_match('/ s="(.*?)"/',$xmlMegavideo,$server);
  preg_match('/ k1="(.*?)"/',$xmlMegavideo,$key1);
  preg_match('/ k2="(.*?)"/',$xmlMegavideo,$key2);
  preg_match('/ un="(.*?)"/',$xmlMegavideo,$hash);
  $myurl = "http://www" . $server[1] . ".megavideo.com/files/" . decrypt($hash[1],$key1[1],$key2[1]) . "/video.flv";

  return $myurl;
}

function hacer_post_request($url, $data, $optional_headers = null)
{
 $params = array('http' => array(
                 'method' => 'POST',
                 'content' => $data
                          ));
           if ($optional_headers !== null) {
               $params['http']['header'] = $optional_headers;
                                            }
         $ctx = stream_context_create($params);
         $fp = @@fopen($url, 'rb', false, $ctx);
           if (!$fp) {
             throw new Exception("Problem with $url, $php_errormsg");
                     }
         $response = @@stream_get_contents($fp);
           if ($response === false) {
             throw new Exception("Problem reading data from $url, $php_errormsg");
                                   }
         return $response;
                     }
?>
