<?php
#------------------------------------------
# Plugin para WDTV Live
# Series Online - Series
#------------------------------------------


include('funciones.php');

include_once('/usr/share/umsp/funcs-log.php');
 

function _pluginMain($prmQuery) {

	$website = 'http://www.serieonline.net/series/';
	$plugin = 'serieonline-series';

	$queryData = array();
	parse_str($prmQuery, $queryData);

	//Estructura P�gina Inicial
	
	
  if ($queryData['inicio'] == 'listadoc') { // Paginacion
	
	  
		$html = file_get_contents($website);	

    preg_match_all('/<div class="paginacion-num"><a href="(.*?)">(.*?)<\/a>/',$html,$todo);
		
		// Metemos primero la primera p�gina ya que no aparece entre los resultados de $todo
		
		$paginas[1][0] = $website;	
		
		$paginas[2][0] = 'Pagina 1';
				
		for ($i = 1; $i <= count($todo[1]); $i++) {
		
		   $paginas[1][$i] = $todo[1][$i-1];
			 
		   $paginas[2][$i] = 'Pagina '.$todo[2][$i-1];
		}	

		
		$lista = array ('titulo' => $paginas[2],'enlace' => $paginas[1]);  

		
		$tipo = 'series';

	}
	
	else if ($queryData['series'] != '') { // Listado de series
	
	  $lista = _CrearLista($queryData['series'],'/<div class="mostrar-series-imagen">[\s|\n|\t]*<a href="(.*?)">[\s|\n|\t]*<img src="(.*?)" alt="(.*?)" height/',array(3,1,2),'');
	  
		$tipo = 'capitulos';
				
	}
        else if ($queryData['temporadas'] !='') {
           $url = $queryData['temporadas'];
           $html = file_get_contents($url);
           $url = str_replace('/','\/',$url);
           preg_match_all('/<a href="('.$url.'temporada-[^\/]*\/?)([^<]*?)</',$html,$todo);
           preg_match_all('/<a href="'.$url.'(temporada-[^\/])*\/?([^<]*?)</',$html,$temp);
           $todo[1]=array_keys(array_count_values($todo[1]));
           $temp[1]=array_keys(array_count_values($temp[1]));
           $lista = array ('titulo' => $temp[1],'enlace' => $todo[1],'url' => $queryData['temporadas']);
           $tipo = 'capitulos';
        }
	
	
	else if ($queryData['capitulos'] != '') { // Listado de capitulos
	
	  $lista = _CrearLista($queryData['capitulos'],'/\/><a href="(.*?)">(.*?)<\/a><br/',array(2,1,-1),'');
		
	  $tipo = 'enlaces';
				
	}
	else if ($queryData['enlaces']!=''){  // Nota: Ni el patron para megavideo ni para el t�tulo existen en la pagina 

                $html = file_get_contents($queryData['enlaces']);
                preg_match_all("/http:\/\/www.megaupload.com\/\?.=(........)/",$html,$mv);
                $codmv[]=$mv[1][0];
                $lista = array ('megavid' => $codmv,'megaup' => $codmv,'titulo' => 'Enlace');
	        return _pluginCreateVideoItems($lista,$plugin);	

	}
	


	// Pagina Inicial
	
	else {

		$lista = array ('titulo' => array ('Listado Completo'),

				 	 			 		'enlace' => array ('listadoc'),

										'caratula' => array ('http://i52.tinypic.com/f4faqo.jpg')   							 		       

		               );

		$tipo = 'inicio';


	}

	
	return _CrearItems($lista,$plugin,$tipo);
}

ob_flush();

?>
